Loading...
Searching...
No Matches
icu::SelectFormat Class Reference

`#include <selfmt.h>`

Inheritance diagram for icu::SelectFormat:

## Public Member Functions

| SelectFormat (const UnicodeString &pattern, UErrorCode &status)
| Creates a new `SelectFormat` for a given pattern string.
| SelectFormat (const SelectFormat &other)
| copy constructor.
virtual | ~SelectFormat ()
| Destructor.
void | applyPattern (const UnicodeString &pattern, UErrorCode &status)
| Sets the pattern used by this select format.
UnicodeString & | format (const UnicodeString &keyword, UnicodeString &appendTo, FieldPosition &pos, UErrorCode &status) const
| Selects the phrase for the given keyword.
SelectFormat & | operator= (const SelectFormat &other)
| Assignment operator.
virtual bool | operator== (const Format &other) const override
| Return true if another object is semantically equal to this one.
virtual bool | operator!= (const Format &other) const
| Return true if another object is semantically unequal to this one.
virtual SelectFormat * | clone () const override
| Clones this Format object polymorphically.
UnicodeString & | format (const Formattable &obj, UnicodeString &appendTo, FieldPosition &pos, UErrorCode &status) const override
| Format an object to produce a string.
UnicodeString & | toPattern (UnicodeString &appendTo)
| Returns the pattern from applyPattern() or constructor.
virtual void | parseObject (const UnicodeString &source, Formattable &result, ParsePosition &parse_pos) const override
| This method is not yet supported by `SelectFormat`.
virtual UClassID | getDynamicClassID () const override
| ICU "poor man's RTTI", returns a UClassID for the actual class.
U_I18N_API UnicodeString & | format (const Formattable &obj, UnicodeString &appendTo, UErrorCode &status) const
| Formats an object to produce a string.
virtual U_I18N_API UnicodeString & | format (const Formattable &obj, UnicodeString &appendTo, FieldPositionIterator *posIter, UErrorCode &status) const
| Format an object to produce a string.
Public Member Functions inherited from icu::Format
virtual U_I18N_API | ~Format ()
| Destructor.
U_I18N_API bool | operator!= (const Format &other) const
| Return true if the given Format objects are not semantically equal.
U_I18N_API UnicodeString & | format (const Formattable &obj, UnicodeString &appendTo, UErrorCode &status) const
| Formats an object to produce a string.
U_I18N_API void | parseObject (const UnicodeString &source, Formattable &result, UErrorCode &status) const
| Parses a string to produce an object.
U_I18N_API Locale | getLocale (ULocDataLocaleType type, UErrorCode &status) const
| Get the locale for this format object.
U_I18N_API const char * | getLocaleID (ULocDataLocaleType type, UErrorCode &status) const
| Get the locale for this format object.
Public Member Functions inherited from icu::UObject
virtual | ~UObject ()
| Destructor.

## Static Public Member Functions

static UClassID | getStaticClassID ()
| ICU "poor man's RTTI", returns a UClassID for this class.

## Friends

class | MessageFormat

## Additional Inherited Members

Protected Member Functions inherited from icu::Format
U_I18N_API void | setLocaleIDs (const char *valid, const char *actual)
U_I18N_API | Format ()
| Default constructor for subclass use only.
U_I18N_API | Format (const Format &)
U_I18N_API Format & | operator= (const Format &)
Static Protected Member Functions inherited from icu::Format
static U_I18N_API void | syntaxError (const UnicodeString &pattern, int32_t pos, UParseError &parseError)
| Simple function for initializing a UParseError from a UnicodeString.

## Detailed Description

`SelectFormat` supports the creation of internationalized messages by selecting phrases based on keywords. The pattern specifies how to map keywords to phrases and provides a default phrase. The object provided to the format method is a string that's matched against the keywords. If there is a match, the corresponding phrase is selected; otherwise, the default phrase is used.

#### Using `SelectFormat` for Gender Agreement

Note: Typically, select formatting is done via `MessageFormat` with a `select` argument type, rather than using a stand-alone `SelectFormat`.

The main use case for the select format is gender based inflection. When names or nouns are inserted into sentences, their gender can affect pronouns, verb forms, articles, and adjectives. Special care needs to be taken for the case where the gender cannot be determined. The impact varies between languages:

- English has three genders, and unknown gender is handled as a special case. Names use the gender of the named person (if known), nouns referring to people use natural gender, and inanimate objects are usually neutral. The gender only affects pronouns: "he", "she", "it", "they".
- German differs from English in that the gender of nouns is rather arbitrary, even for nouns referring to people ("Mädchen", girl, is neutral). The gender affects pronouns ("er", "sie", "es"), articles ("der", "die", "das"), and adjective forms ("guter Mann", "gute Frau", "gutes Mädchen").
- French has only two genders; as in German the gender of nouns is rather arbitrary - for sun and moon, the genders are the opposite of those in German. The gender affects pronouns ("il", "elle"), articles ("le", "la"), adjective forms ("bon", "bonne"), and sometimes verb forms ("allé", "allée").
- Polish distinguishes five genders (or noun classes), human masculine, animate non-human masculine, inanimate masculine, feminine, and neuter.

Some other languages have noun classes that are not related to gender, but similar in grammatical use. Some African languages have around 20 noun classes.

Note:For the gender of a person in a given sentence, we usually need to distinguish only between female, male and other/unknown.

To enable localizers to create sentence patterns that take their language's gender dependencies into consideration, software has to provide information about the gender associated with a noun or name to `MessageFormat`. Two main cases can be distinguished:

- For people, natural gender information should be maintained for each person. Keywords like "male", "female", "mixed" (for groups of people) and "unknown" could be used.

- For nouns, grammatical gender information should be maintained for each noun and per language, e.g., in resource bundles. The keywords "masculine", "feminine", and "neuter" are commonly used, but some languages may require other keywords.

The resulting keyword is provided to `MessageFormat` as a parameter separate from the name or noun it's associated with. For example, to generate a message such as "Jean went to Paris", three separate arguments would be provided: The name of the person as argument 0, the gender of the person as argument 1, and the name of the city as argument 2. The sentence pattern for English, where the gender of the person has no impact on this simple sentence, would not refer to argument 1 at all:

    {0} went to {2}.

Note: The entire sentence should be included (and partially repeated) inside each phrase. Otherwise translators would have to be trained on how to move bits of the sentence in and out of the select argument of a message. (The examples below do not follow this recommendation!)

The sentence pattern for French, where the gender of the person affects the form of the participle, uses a select format based on argument 1:

    {0} est {1, select, female {allée} other {allé}} à {2}.

Patterns can be nested, so that it's possible to handle interactions of number and gender where necessary. For example, if the above sentence should allow for the names of several people to be inserted, the following sentence pattern can be used (with argument 0 the list of people's names, argument 1 the number of people, argument 2 their combined gender, and argument 3 the city name):

    {0} {1, plural,
                    one {est {2, select, female {allée} other  {allé}}}
                    other {sont {2, select, female {allées} other {allés}}}
             }à {3}.

#### Patterns and Their Interpretation

The `SelectFormat` pattern string defines the phrase output for each user-defined keyword. The pattern is a sequence of (keyword, message) pairs. A keyword is a "pattern identifier": [^[[:Pattern_Syntax:][:Pattern_White_Space:]]]+

Each message is a MessageFormat pattern string enclosed in {curly braces}.

You always have to define a phrase for the default keyword `other`; this phrase is returned when the keyword provided to the `format` method matches no other keyword. If a pattern does not provide a phrase for `other`, the method it's provided to returns the error `U_DEFAULT_KEYWORD_MISSING`.
Pattern_White_Space between keywords and messages is ignored. Pattern_White_Space within a message is preserved and output.

    Example:

    UErrorCode status = U_ZERO_ERROR;
    MessageFormat *msgFmt = new MessageFormat(UnicodeString("{0} est  {1, select, female {allée} other {allé}} à Paris."), Locale("fr"),  status);
    if (U_FAILURE(status)) {
          return;
    }
    FieldPosition ignore(FieldPosition::DONT_CARE);
    UnicodeString result;

    char* str1= "Kirti,female";
    Formattable args1[] = {"Kirti","female"};
    msgFmt->format(args1, 2, result, ignore, status);
    cout << "Input is " << str1 << " and result is: " << result << endl;
    delete msgFmt;

Produces the output:
`Kirti est allée à Paris.`

Stable
  ICU 4.4

Definition at line 188 of file selfmt.h.

## Constructor & Destructor Documentation

## SelectFormat() [1/2]

icu::SelectFormat::SelectFormat | ( | const UnicodeString & | pattern,
|  | UErrorCode & | status )

Creates a new `SelectFormat` for a given pattern string.

Parameters

  pattern | the pattern for this `SelectFormat`. errors are returned to status if the pattern is invalid.
  status | output param set to success/failure code on exit, which must not indicate a failure before the function call.

Stable
  ICU 4.4

Referenced by clone(), getDynamicClassID(), operator=(), and SelectFormat().

## SelectFormat() [2/2]

icu::SelectFormat::SelectFormat | ( | const SelectFormat & | other | ) |

copy constructor.

Stable
  ICU 4.4

References SelectFormat().

## ~SelectFormat()

virtual icu::SelectFormat::~SelectFormat | ( |  | ) |

virtual

Destructor.

Stable
  ICU 4.4

## Member Function Documentation

## applyPattern()

void icu::SelectFormat::applyPattern | ( | const UnicodeString & | pattern,
|  | UErrorCode & | status )

Sets the pattern used by this select format.

for the keyword rules. Patterns and their interpretation are specified in the class description.

Parameters

  pattern | the pattern for this select format errors are returned to status if the pattern is invalid.
  status | output param set to success/failure code on exit, which must not indicate a failure before the function call.

Stable
  ICU 4.4

References icu::Format::format().

## clone()

virtual SelectFormat * icu::SelectFormat::clone | ( |  | ) | const

override virtual

Clones this Format object polymorphically.

The caller owns the result and should delete it when done.

Stable
  ICU 4.4

Implements icu::Format.

References SelectFormat().

## format() [1/4]

UnicodeString & icu::SelectFormat::format | ( | const Formattable & | obj,
|  | UnicodeString & | appendTo,
|  | FieldPosition & | pos,
|  | UErrorCode & | status ) const

override virtual

Format an object to produce a string.

This method handles keyword strings. If the Formattable object is not a `UnicodeString`, then it returns a failing UErrorCode.

Parameters

  obj | A keyword string that is used to select an alternative.
  appendTo | output parameter to receive result. Result is appended to existing contents.
  pos | On input: an alignment field, if desired. On output: the offsets of the alignment field.
  status | output param filled with success/failure status.

Returns
  Reference to 'appendTo' parameter.

Stable
  ICU 4.4

Implements icu::Format.

## format() [2/4]

virtual U_I18N_API UnicodeString & icu::Format::format | ( | const Formattable & | obj,
|  | UnicodeString & | appendTo,
|  | FieldPositionIterator * | posIter,
|  | UErrorCode & | status ) const

virtual

Format an object to produce a string.

Subclasses should override this method. This method allows polymorphic formatting of Formattable objects. If a subclass of Format receives a Formattable object type it doesn't handle (e.g., if a numeric Formattable is passed to a DateFormat object) then it returns a failing UErrorCode.

Parameters

  obj | The object to format.
  appendTo | Output parameter to receive result. Result is appended to existing contents.
  posIter | On return, can be used to iterate over positions of fields generated by this format call.
  status | Output param filled with success/failure status.

Returns
  Reference to 'appendTo' parameter.

Stable
  ICU 4.4

Reimplemented from icu::Format.

## format() [3/4]

U_I18N_API UnicodeString & icu::Format::format | ( | const Formattable & | obj,
|  | UnicodeString & | appendTo,
|  | UErrorCode & | status ) const

Formats an object to produce a string.

Parameters

  obj | The object to format.
  appendTo | Output parameter to receive result. Result is appended to existing contents.
  status | Output parameter filled in with success or failure status.

Returns
  Reference to 'appendTo' parameter.

Stable
  ICU 2.0

## format() [4/4]

UnicodeString & icu::SelectFormat::format | ( | const UnicodeString & | keyword,
|  | UnicodeString & | appendTo,
|  | FieldPosition & | pos,
|  | UErrorCode & | status ) const

Selects the phrase for the given keyword.

Parameters

  keyword | The keyword that is used to select an alternative.
  appendTo | output parameter to receive result. result is appended to existing contents.
  pos | On input: an alignment field, if desired. On output: the offsets of the alignment field.
  status | output param set to success/failure code on exit, which must not indicate a failure before the function call.

Returns
  Reference to 'appendTo' parameter.

Stable
  ICU 4.4

## getDynamicClassID()

virtual UClassID icu::SelectFormat::getDynamicClassID | ( |  | ) | const

override virtual

ICU "poor man's RTTI", returns a UClassID for the actual class.

Stable
  ICU 4.4

Reimplemented from icu::UObject.

References SelectFormat().

## getStaticClassID()

UClassID icu::SelectFormat::getStaticClassID | ( |  | ) |

static

ICU "poor man's RTTI", returns a UClassID for this class.

Stable
  ICU 4.4

## operator!=()

virtual bool icu::SelectFormat::operator!= | ( | const Format & | other | ) | const

virtual

Return true if another object is semantically unequal to this one.

Parameters

  other | the SelectFormat object to be compared with.

Returns
  true if other is semantically unequal to this.

Stable
  ICU 4.4

References icu::Format::Format().

## operator=()

SelectFormat & icu::SelectFormat::operator= | ( | const SelectFormat & | other | ) |

Assignment operator.

Parameters

  other | the SelectFormat object to copy from.

Stable
  ICU 4.4

References SelectFormat().

## operator==()

virtual bool icu::SelectFormat::operator== | ( | const Format & | other | ) | const

override virtual

Return true if another object is semantically equal to this one.

Parameters

  other | the SelectFormat object to be compared with.

Returns
  true if other is semantically equal to this.

Stable
  ICU 4.4

Implements icu::Format.

References icu::Format::Format().

## parseObject()

virtual void icu::SelectFormat::parseObject | ( | const UnicodeString & | source,
|  | Formattable & | result,
|  | ParsePosition & | parse_pos ) const

override virtual

This method is not yet supported by `SelectFormat`.

Before calling, set parse_pos.index to the offset you want to start parsing at in the source. After calling, parse_pos.index is the end of the text you parsed. If error occurs, index is unchanged.

When parsing, leading whitespace is discarded (with a successful parse), while trailing whitespace is left as is.

See Format::parseObject() for more.

Parameters

  source | The string to be parsed into an object.
  result | Formattable to be set to the parse result. If parse fails, return contents are undefined.
  parse_pos | The position to start parsing at. Upon return this param is set to the position after the last character successfully parsed. If the source is not parsed successfully, this param will remain unchanged.

Stable
  ICU 4.4

Implements icu::Format.

## toPattern()

UnicodeString & icu::SelectFormat::toPattern | ( | UnicodeString & | appendTo | ) |

Returns the pattern from applyPattern() or constructor.

Parameters

  appendTo | output parameter to receive result. Result is appended to existing contents.

Returns
  the UnicodeString with inserted pattern.

Stable
  ICU 4.4

## Friends And Related Symbol Documentation

## MessageFormat

friend class MessageFormat

friend

Definition at line 349 of file selfmt.h.

The documentation for this class was generated from the following file:

- i18n/unicode/selfmt.h